
# -*- encoding:euc-jp -*-

# ƥץ졼̤Υƥ

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"

class AmritaTest < Test::Unit::TestCase
  # ִ
  def test10
    # ǤƤִ롣id°Ϻ롣
    tmpl = Amrita::TemplateText.new("<h1 id=r>head</h1><p id=s>text</p>")
    r = ""
    tmpl.expand(r, {:r => "ok", :s => "replaced"})
    assert_equal("<h1>ok</h1><p>replaced</p>", r)

    # < > & ϥפ롣' " ϥפʤ
    r = ""
    tmpl.expand(r, {
      :r => "<>&'\"",
      :s => "   \n   "
    })
    assert_equal("<h1>&lt;&gt;&amp;'\"</h1><p>   \n   </p>", r)
  end
  
  # trueϤȤΤޤ
  def test11
    tmpl = Amrita::TemplateText.new('<x id="e"></x>')
    r = ""
    tmpl.expand(r, {:e => true})
    assert_equal('<x></x>', r)
  end

  # ֤
  def test40
    # ֤ȤϡϤॿǤϤʤ֤id°դ롣
    tmpl = Amrita::TemplateText.new("<ul><li id=list>foo</ul>")
    r = ""

    # ƤϡʸʤʸѴǤ륪֥ȡˤͿ
    tmpl.expand(r, {
      :list => [1, "foo"]
    })
    assert_equal("<ul><li>1</li><li>foo</li></ul>", r)
  end

  def test41
    tmpl = Amrita::TemplateText.new("<table><tr id=t><td id=n><td id=v></table>")
    r = ""

    tmpl.expand(r, {
      :t => [    # ֤
           {     # Ǥ򤷤ִȤϥϥå
             :n => "ǽ", :v => ""}]
    })
    assert_equal("<table><tr><td>ǽ</td><td></td></tr></table>", r)
  end
  
  # ʬ
  def test60
    tmpl = Amrita::TemplateText.new("<div id=n>foo</div><div id=o>bar</div>")
    r = ""

    tmpl.expand(r, {:n => false}) # nil or falseϡǤ
    assert_equal("", r)   # id°expand()ʤäǤϤ٤ƺ
                          # inputʤɤʤ褦ˡamrita°̾Ū˻ꤹ
  end

  # XMLǤϡ:פ̾°̾Ȥƴޤޤ
  def test70
    tmpl = Amrita::TemplateText.new(<<EOF)
<?xml version="1.0"?>
<foo xmlns:t="amrita"><p t:tmplid="foo">should be replaced</p></foo>
EOF
    r = ""
    tmpl.amrita_id = "t:tmplid"
    tmpl.expand(r, {:foo => "ok"})
    assert_equal(<<EOF, r)
<?xml version="1.0"?>
<foo xmlns:t="amrita"><p>ok</p></foo>
EOF
  end

  # Ƥζ¸롣
  def test81
    tmpl = Amrita::TemplateText.new "<pre>   \nhoge\n   </pre>"
    r = ""
    tmpl.expand(r, {})
    assert_equal("<pre>   \nhoge\n   </pre>", r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(AmritaTest)
end
