
# °ִͤΥƥȡAmrita 1.0.2ξϡѥåƤ뤳

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"

class AmAttrTest < Test::Unit::TestCase
  include Amrita
  
  # ץִ
  def test10
    tmpl = TemplateText.new '<html><input name="@n"></html>'
    model = { :n => "foo" }
    r = ""
    tmpl.expand(r, model)
    assert_equal('<html><input name="foo"></html>', r)
  end

  # Amrita.a()ˤִ
  def test20
    tmpl = TemplateText.new '<a id=link>foo</a>'
    model = { :link => Amrita.a(:href => "http://hoge") }
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a href="http://hoge">foo</a>', r)

    # °ͤηURLξϸå
    # ǥǡʸޤޤ硢°ͤ϶ˤʤ
    r = ""
    tmpl.expand(r, {:link => Amrita.a(:href => "<>&'\"")})
    assert_equal('<a href="">foo</a>', r)
  end

  # Amrita.a()ǡ°ͤƤƱִ
  def test21
    tmpl = TemplateText.new '<a id=link>foo</a>'
    model = {:link => Amrita.a(:href => "http://foo", :name => "link") {"anchor text"} }

    tmpl.use_compiler = false
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a name="link" href="http://foo">anchor text</a>', r)

    tmpl.use_compiler = true
    r = ""
    tmpl.expand(r, model)
    assert_equal('<a name="link" href="http://foo">anchor text</a>', r)
  end

  # ҤˤʤäǤΤǤ°Τִ
  # Amrita.a()
  def test25
    tmpl = TemplateText.new("<tr id=r><td id=a>foo<td id=r>bar</tr>")
    model = {
      :r => {:r => Amrita.a(:a => "hoge") {"text"} } }

    r = ""
    tmpl.expand(r, model)
    assert_equal('<tr><td a="hoge">text</td></tr>', r)
  end

  # Amrita.a()Ǥϡ֥åȤʸ󤷤ʤ
  # @nameǽ˻ꤹ
  def test26
    tmpl = TemplateText.new(
                    '<tr style="@s"><td id=a>foo<td id="in" style="@s">bar</tr>')
    model_a = {
      :s => "font:hoge" }
    model_b = {
      :in => {:s => "font:bar"} }

    r = ""
    tmpl.expand(r, model_a)
    assert_equal('<tr style="font:hoge"></tr>', r)

    r = ""
    tmpl.expand(r, model_b)
    assert_equal('<tr><td style="font:bar">bar</td></tr>', r)
  end

  # Ҵط°ִͤ
  def test31
    tmpl = TemplateText.new('<foo id="a" bar="@hoge">hogehoge</foo>')
    model_a = {:a => "text", :hoge => "attr"}
    model_b = {:a => {:hoge => "attr"}}
    model_c = {:a => {:hoge => nil}}
    r = ""
    tmpl.expand(r, model_c)
    assert_equal('<foo>hogehoge</foo>', r)
    r = ""
    tmpl.expand(r, model_b)
    assert_equal('<foo bar="attr">hogehoge</foo>', r)
    r = ""
    tmpl.expand(r, model_a)
    assert_equal('<foo>text</foo>', r)
  end
  
  # ǥ°ִͤ
  def test41
    tmpl = TemplateText.new('<hr style="@s">')
    r = ""
    tmpl.expand(r, {:s => "color:red"})
    assert_equal('<hr style="color:red">', r)
  end
  
  # °ͤϤ.to_s()Τˤʤ
  def test51
    tmpl = TemplateText.new('<foo style="@s" v="@t"></foo>')
    tmpl.expand_attr = true
    r = ""
    tmpl.expand(r, {:s => [1, 2, 3], :t => {"a" => "b"}})
    assert_equal('<foo style="123" v="ab"></foo>', r)
  end
  
  # °ͤtrueϤȡtrueˤʤ롣
  def test52
    tmpl = TemplateText.new('<x s="@s"></x>')
    r = ""
    tmpl.expand(r, {:s => true})
    assert_equal('<x s="true"></x>', r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(AmAttrTest)
end
