
# -*- encoding:utf-8 -*-

# 交互置換のテスト

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"

class MultiTest < Test::Unit::TestCase
  # 両方を展開
  def test10
    tmpl = Amrita::TemplateText.new('<li s=u id="t">foo<li s=v id="t">bar')
    r = ""
    tmpl.expand(r, {:t => ["a", "b"]})
    assert_equal('<li s="u">a</li><li s="u">b</li><li s="v">a</li><li s="v">b</li>', r)
  end

  # 交互に展開
  def test20
    tmpl = Amrita::TemplateText.new('<li s=u id="t+">foo<li s=v id="t+">bar')
    r = ""
    tmpl.expand(r, {:t => ["a", "b"]})
    assert_equal('<li s="u">a</li><li s="v">b</li>', r)
  end
  
  # ハッシュ
  def test21
    tmpl = Amrita::TemplateText.new('<tr id="t+">foo<x id="x"></x></tr><tr id="t+">bar<x id="x"></x></tr>')
    r = ""
    tmpl.expand(r, {:t => [{:x => "hoge"}, {:x => "hogehoge"}]})
    assert_equal('<tr>foo<x>hoge</x></tr><tr>bar<x>hogehoge</x></tr>', r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(MultiTest)
end
