
# -*- encoding:euc-jp -*-

require "test/unit"
require "test/unit/ui/console/testrunner"

require "amrita/template"
require "amrita/xml"

class AmXmlTest < Test::Unit::TestCase
  include Amrita
  
  # XMLѡȤ硢ƥץ졼ȤǤвǤ⤤
  # XMLʸǤɬפϤʤ
  def test10
    r = XMLParser.parse_text "<p>foo<hr/>bar</p>"
    assert_equal e(:p){["foo", e(:hr), "bar"]}, r
  end
  
  def test11
    r = XMLParser.parse_file "data/f"
    assert_equal e(:foo){["\n  hoge\n  ", e(:bar), "\n  ", e(:baz){"hogehoge"}, "\n"]}, r
  end

  # ʥ
  def test12
    t = <<EOF
<?xml version="1.0"?><?xml-stylesheet href="mystyle.css" type="text/css"?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html><!-- comment --><![CDATA[...]]></html>
EOF
    r = XMLParser.parse_text t
    assert_equal t.chop + " ", r.to_s
  end
  
  # XML⡼ɤΤȤHTMLǤζǥ̵뤹
  def test21
    t = "<foo><hr>hoge</hr></foo>"
    tmpl = TemplateText.new(t)
    tmpl.xml = true
    r = ""
    tmpl.expand(r, {})
    assert_equal(t, r)
  end
  
  # HTMLǤ°ͤʤ
  def test22
    tmpl = TemplateText.new('<a href=">>" />')
    tmpl.xml = true
    r = ""
    tmpl.expand(r, {})
    assert_equal('<a href="&gt;&gt;" />', r)
  end
end

if __FILE__ == $0
  Test::Unit::UI::Console::TestRunner.run(AmXmlTest)
end
